[comment {-*- tcl -*- doctools manpage}]
[include parts/definitions.inc]
[vset VERSION 1]
[manpage_begin [vset LABEL_RENDER] [vset MAN_SECTION] [vset VERSION]]
[include parts/module.inc]
[keywords render interpolation]
[require mustache::render]
[titledesc [vset TITLE_RENDER]]
[description]
[include parts/welcome.inc]

[section Overview]

The package [package mustache::render] provides the renderer for
[vset project/upstream] templates.

[section Commands]

[list_begin definitions]
[comment {- - -- --- ----- -------- -------------}]
[call [cmd ::mustache] [method render] \
     [arg template] [arg context] [arg writer]]

This command takes the data structure representing a parsed

[vset project/upstream] template (as generated by the
[cmd {mustache parse}] command provided by package

[package mustache::parse]), a [arg context] as the source of the data
to interpolate, and a [arg writer] representing the destination of the
interpolation result.

[para] Both [arg context] and [arg writer] are command prefixes.  Both
will be invoked in arbitrarly deeply nested scopes of the rendering
operation.

[para] The [arg context] command prefix has to support the instance
API of [package mustache::context] objects.

[para] The [arg writer] command prefix has to accept a single
argument, the text to print. Note that it may be invoked multiple
times as the template is rendered.

[list_end]

[include parts/feedback.inc]
[manpage_end]
