'\"
'\" Generated from file 'mustache_changes\&.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2019-2021 Andreas Kupries
'\" Copyright (c) 2019-2021 Documentation, Andreas Kupries
'\"
.TH "mustache-changes" n 1\&.1 doc "Mustache\&. Packages for logic-less templating"
.\" The -*- nroff -*- definitions below are for supplemental macros used
.\" in Tcl/Tk manual entries.
.\"
.\" .AP type name in/out ?indent?
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS ?type? ?name?
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .CS
.\"	Begin code excerpt.
.\"
.\" .CE
.\"	End code excerpt.
.\"
.\" .VS ?version? ?br?
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.  The first argument is ignored and used for recording
.\"	the version when the .VS was added, so that the sidebars can be
.\"	found and removed when they reach a certain age.  If another argument
.\"	is present, then a line break is forced before starting the sidebar.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
.\" .SO ?manpage?
.\"	Start of list of standard options for a Tk widget. The manpage
.\"	argument defines where to look up the standard options; if
.\"	omitted, defaults to "options". The options follow on successive
.\"	lines, in three columns separated by tabs.
.\"
.\" .SE
.\"	End of list of standard options for a Tk widget.
.\"
.\" .OP cmdName dbName dbClass
.\"	Start of description of a specific option.  cmdName gives the
.\"	option's name as specified in the class command, dbName gives
.\"	the option's name in the option database, and dbClass gives
.\"	the option's class in the option database.
.\"
.\" .UL arg1 arg2
.\"	Print arg1 underlined, then print arg2 normally.
.\"
.\" .QW arg1 ?arg2?
.\"	Print arg1 in quotes, then arg2 normally (for trailing punctuation).
.\"
.\" .PQ arg1 ?arg2?
.\"	Print an open parenthesis, arg1 in quotes, then arg2 normally
.\"	(for trailing punctuation) and then a closing parenthesis.
.\"
.\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
.\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1 \\fI\\$2\\fP (\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
.\"	# BS - start boxed text
.\"	# ^y = starting y location
.\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
.\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
.\"	# VS - start vertical sidebar
.\"	# ^Y = starting y location
.\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
.\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
.\"	# Special macro to handle page bottom:  finish off current
.\"	# box/sidebar if in box/sidebar mode, then invoked standard
.\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
.\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
.\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\"	# SO - start of list of standard options
.de SO
'ie '\\$1'' .ds So \\fBoptions\\fR
'el .ds So \\fB\\$1\\fR
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
.\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\*(So manual entry for details on the standard options.
..
.\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
.\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
.\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.\"	# UL - underline word
.de UL
\\$1\l'|0\(ul'\\$2
..
.\"	# QW - apply quotation marks to word
.de QW
.ie '\\*(lq'"' ``\\$1''\\$2
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\$2
..
.\"	# PQ - apply parens and quotation marks to word
.de PQ
.ie '\\*(lq'"' (``\\$1''\\$2)\\$3
.\"" fix emacs highlighting
.el (\\*(lq\\$1\\*(rq\\$2)\\$3
..
.\"	# QR - quoted range
.de QR
.ie '\\*(lq'"' ``\\$1''\\-``\\$2''\\$3
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\-\\*(lq\\$2\\*(rq\\$3
..
.\"	# MT - "empty" string
.de MT
.QW ""
..
.BS
.SH NAME
mustache-changes \- Mustache - Log of Changes
.SH DESCRIPTION
.PP
Welcome to the Mustache project for Tcl, written by
Andreas Kupries\&.
.PP
It provides a set of five related Tcl packages for the parsing
and rendering of \fImustache\fR [https://mustache\&.github\&.io/]-style logic-less templates,
plus an application for easy command-line access to the functionality\&.
.PP
For availability please read \fIMustache - How To Get The Sources\fR\&.
.PP
This document provides an overview of the changes \fBmustache\fR
underwent from version to version\&.
.SH CHANGES
.SS "CHANGES FOR VERSION 1\&.2"
\fIVersion 1\&.2 is in development and has not been released yet\fR
.IP [1]
\fIAttention\fR
.sp
Added a new \fBstring!\fR type to the
\fBmustache::frame\fR package\&.
.sp
It is strongly recommended to use this type for any kind of
string value instead of old type \fBstring\fR (without a
trailing \fI!\fR\&.
.sp
Why ?
.sp
The original \fBstring\fR type is coded to match the
expectations of the mustache specification, as laid down by its
official compatibility testsuite\&.
.sp
This includes some very weird behaviour for a \fBstring\fR
type: It "normalizes" any string which looks like a double
number, which means anything which looks numeric\&. That is a
very bad thing to do when your strings are, for example file
and directory names, just looking like numbers\&. Then you call
such normalization "mangling" instead and start cursing\&.
.sp
The new \fBstring!\fR type does no such mangling\&.
.sp
The new type is now the standard type when converting to and
from YAML, and other such representations\&. I\&.e\&. an external
string is mapped to \fBstring!\fR now\&.
.sp
Existing code using \fBstring\fR directly in the construction
of frames has to be manually converted to use \fBstring!\fR
however\&.
.IP [2]
Extended the \fBmustache::frame\fR package with several
methods specific to scalars and mappings, and one generic\&.
.sp
It is now possible to change a scalar's value in place, as well as
add, remove, and move key/value assignments in a mapping\&.
.sp
The new generic method simplifies the writing of type checks\&.
Instead of
.CS

[$frame type] eq "mapping"
.CE
.IP
it is now possible to write
.CS

[$frame is mapping]
.CE
.IP
etc\&.
.PP
.SS "CHANGES FOR VERSION 1\&.1"
.IP [1]
Extended the \fBmustache::frame\fR package to support the
\fITclYAML\fR [https://core\&.tcl-lang\&.org/akupries/tclyaml] version 0\&.5 tags for \fBbool\fR,
\fBfloat\fR, \fBint\fR, \fBnull\fR, and \fBstring\fR\&.
.sp
The pre-existing tag \fBscalar\fR is now a an alias for
\fBstring\fR\&.
.sp
This extension of the type system makes it easier to use
mustache's data frames as an in-memory representation for
structured typed data\&. No automatic loss of type data inside of
Tcl scripts now\&.
.IP [2]
Extended the data frames provided by package
\fBmustache::frame\fR with methods for walking a frame tree
in general, and simplifying the conversion back into external
serialization formats\&.
.IP [3]
Extended the sequence and mapping data frames provided by
package \fBmustache::frame\fR with methods (\fBfor\fR)
for iteration over the content, without a context\&.
.IP [4]
Added packages for the conversion of a data frame (tree) into
various serializations:
.RS
.TP
\fBmustache::frame::as::events\fR
Serialization into a list of events describing the incremental build of the tree\&.
.TP
\fBmustache::frame::as::json\fR
Serialization into whitespace-free \fIJSON\fR [https://json\&.org/]\&.
.TP
\fBmustache::frame::as::tagged\fR
Serialization into the kind of tagged structure accepted by
\fITclYAML\fR [https://core\&.tcl-lang\&.org/akupries/tclyaml]'s \fBwriteTags\fR command\&.
.RE
.PP
.SS "CHANGES FOR VERSION 1"
This is the first release of mustache\&.
The changes therefore describe the initial features of the system\&.
.PP
In detail:
.IP [1]
mustache requires Tcl 8\&.5 or higher\&.
Tcl 8\&.4 or less is not supported\&.
.IP [2]
mustache requires TclOO\&.
.IP [3]
The project provides several high- and low-level packages for
the parsing and rendering of logic-less templates as specified
by Ruby's \fBmustache\fR package\&.
.PP
.SH "RELATED DOCUMENTS"
.IP [1]
\fIMustache - Introduction to the project\fR
.IP [2]
\fIMustache - License\fR
.IP [3]
\fIMustache - Log of Changes\fR
.IP [4]
\fIMustache - How To Get The Sources\fR
.IP [5]
\fIMustache - The Installer's Guide\fR
.IP [6]
\fIMustache - The Developer's Guide\fR
.PP
.SH "BUGS, IDEAS, FEEDBACK"
Both the package(s) and this documentation will undoubtedly contain
bugs and other problems\&.
Please report such at \fIMustache Tracker\fR [https://core\&.tcl-lang\&.org/akupries/mustache]\&.
.PP
Please also report any ideas you may have for enhancements of
either package(s) and/or documentation\&.
.SH KEYWORDS
logic-less templates, mustache, templating
.SH COPYRIGHT
.nf
Copyright (c) 2019-2021 Andreas Kupries
Copyright (c) 2019-2021 Documentation, Andreas Kupries

.fi
