
[//000000001]: # (mustache::render \- Mustache\. Packages for logic\-less templating)
[//000000002]: # (Generated from file 'mustache\_render\.man' by tcllib/doctools with format 'markdown')
[//000000003]: # (Copyright &copy; 2019\-2021 Andreas Kupries)
[//000000004]: # (Copyright &copy; 2019\-2021 Documentation, Andreas Kupries)
[//000000005]: # (mustache::render\(n\) 1 doc "Mustache\. Packages for logic\-less templating")

<hr> [ <a href="../../../../../../home">Home</a> &#124; <a
href="../../toc.md">Main Table Of Contents</a> &#124; <a
href="../toc.md">Table Of Contents</a> &#124; <a
href="../../index.md">Keyword Index</a> ] <hr>

# NAME

mustache::render \- Mustache \- Rendering parsed templates

# <a name='toc'></a>Table Of Contents

  - [Table Of Contents](#toc)

  - [Synopsis](#synopsis)

  - [Description](#section1)

  - [Overview](#section2)

  - [Commands](#section3)

  - [Bugs, Ideas, Feedback](#section4)

  - [Keywords](#keywords)

  - [Copyright](#copyright)

# <a name='synopsis'></a>SYNOPSIS

package require mustache::render  

[__::mustache__ __render__ *template* *context* *writer*](#1)  

# <a name='description'></a>DESCRIPTION

Welcome to the Mustache project for Tcl, written by Andreas Kupries\.

It provides a set of five related Tcl packages for the parsing and rendering of
[mustache](https://mustache\.github\.io/)\-style logic\-less templates, plus an
application for easy command\-line access to the functionality\.

For availability please read *[Mustache \- How To Get The
Sources](mustache\_howto\_get\_sources\.md)*\.

# <a name='section2'></a>Overview

The package __mustache::render__ provides the renderer for
[mustache](https://mustache\.github\.io/) templates\.

# <a name='section3'></a>Commands

  - <a name='1'></a>__::mustache__ __render__ *template* *context* *writer*

    This command takes the data structure representing a parsed
    [mustache](https://mustache\.github\.io/) template \(as generated by the
    __mustache parse__ command provided by package
    __[mustache::parse](mustache\_parse\.md)__\), a *context* as the
    source of the data to interpolate, and a *writer* representing the
    destination of the interpolation result\.

    Both *context* and *writer* are command prefixes\. Both will be invoked
    in arbitrarly deeply nested scopes of the rendering operation\.

    The *context* command prefix has to support the instance API of
    __[mustache::context](mustache\_context\.md)__ objects\.

    The *writer* command prefix has to accept a single argument, the text to
    print\. Note that it may be invoked multiple times as the template is
    rendered\.

# <a name='section4'></a>Bugs, Ideas, Feedback

Both the package\(s\) and this documentation will undoubtedly contain bugs and
other problems\. Please report such at [Mustache
Tracker](https://core\.tcl\-lang\.org/akupries/mustache)\.

Please also report any ideas you may have for enhancements of either package\(s\)
and/or documentation\.

# <a name='keywords'></a>KEYWORDS

[interpolation](\.\./\.\./index\.md\#interpolation), [logic\-less
templates](\.\./\.\./index\.md\#logic\_less\_templates),
[mustache](\.\./\.\./index\.md\#mustache), [render](\.\./\.\./index\.md\#render),
[templating](\.\./\.\./index\.md\#templating)

# <a name='copyright'></a>COPYRIGHT

Copyright &copy; 2019\-2021 Andreas Kupries  
Copyright &copy; 2019\-2021 Documentation, Andreas Kupries
